package org.freecompany.imp;

import java.io.*;
import java.util.*;
import org.apache.tools.ant.taskdefs.*;

import static org.apache.tools.ant.taskdefs.Ant.*;

/**
 * This is a subclass of the standard Ant task that exposes the member field values
 * necessary to properly control the build from within Imp.  In particular, the dir
 * attribute is necessary for logging output and the targets are needed in order to
 * determine what is executing.
 * 
 * Notes:
 * 
 * There are our copies of the actual task members that are internal to the <@see Ant/>
 * task but are completely inaccessible due to both its access level and the lack of
 * any accessors.  If this is ever corrected in Ant we should be sure to eliminate this
 * otherwise needless duplication.
 */
public class AntOverride extends Ant {

	protected File dir;
	protected List< String> targets = new LinkedList< String>();

	public AntOverride() {
		setInheritAll( false);
	}

	public void setDir( File dir) {
		super.setDir( dir);
		this.dir = dir;
	}

	public File getDir() {
		return dir;
	}

	public void setTarget( String target) {
		super.setTarget( target);
		targets.add( target);
	}

	public List< String> getTargets() {
		return targets;
	}
}
