package org.freecompany.imp;

import java.io.*;
import java.net.*;
import java.nio.channels.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.types.*;

public class Copy extends Task {

	protected String uri;
	protected File tofile;
	protected boolean filtering;

	public void setUri( String uri) {
		this.uri = uri;
	}

	public void setTofile( File tofile) {
		this.tofile = tofile;
	}

	public void setFiltering( final boolean filtering) {
		this.filtering = filtering;
	}

	public void execute() throws BuildException {
		if ( uri == null) throw new BuildException( "The 'uri' attribute is required.");
		if ( tofile == null) throw new BuildException( "The 'tofile' attribute is required.");

		try {
			final FilterSetCollection filters = new FilterSetCollection();
			if ( filtering) filters.addFilterSet( getProject().getGlobalFilterSet());
			
			
			final FileWriter output = new FileWriter( tofile);
			final BufferedReader reader = new BufferedReader( new InputStreamReader( new URI( uri).toURL().openStream()));
			String line;
			while (( line = reader.readLine()) != null) {
				line = filters.replaceTokens(line);
				output.write( line);
			}
			
			reader.close();
			output.close();
		} catch ( Exception e) {
			throw new BuildException( e);
		}
	}
}
