package org.freecompany.imp;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.List;
import java.util.ArrayList;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.DataType;
import org.apache.tools.ant.types.Parameter;

import static org.freecompany.brimstone.cache.Util.loadToCache;

public class Style extends DataType {

	protected final List< Parameter> parameters = new ArrayList< Parameter>();
	protected URL url;

	public void addParameter( final Parameter parameter) {
		parameters.add( parameter);
	}

	public List< Parameter> getParameters() {
		return parameters;
	}

	public void setUri( final String uri) throws BuildException {
		try {
			this.url = loadToCache( Util.loadUrl( getProject(), uri).toURI()).toURL();
		} catch ( URISyntaxException e) {
			throw new BuildException( e);
		} catch ( IOException e) {
			throw new BuildException( e);
		}
	}

	public void setStylesheet( final File file) throws BuildException {
		try {
			this.url = file.toURL();
		} catch ( IOException e) {
			throw new BuildException( e);
		}
	}

	public URL getUrl() {
		return url;
	}
}
