package org.freecompany.imp;

import java.io.*;
import java.util.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;

import static org.freecompany.imp.Constants.*;

public class Subprojects extends Task {

	protected String target;

	/**
	 * Executes the entire set of subprojects for a given target.  This should be called from any
	 * main level target that needs to trigger the appropriate build step in the subprojects.
	 **/
	@SuppressWarnings({ "unchecked" }) public void execute() {
		List< AntOverride> subprojects = ( List< AntOverride>) getProject().getReference( REFERENCE_SUBPROJECTS);
		for ( AntOverride ant : subprojects) {
			log( "Running target '" + target + "' on subproject '" + ant.getDir() + "'.");
			ant.setProject( getProject());
			ant.setTarget( target);
			ant.execute();
		}
	}

	public void setTarget( String target) {
		this.target = target;
	}
}
