package org.freecompany.imp.index;

import org.freecompany.imp.*;
import org.apache.tools.ant.*;
import org.w3c.dom.*;
import java.io.*;
import javax.xml.parsers.*;

public abstract class Generator {

	protected Project project;
	protected String name;
	protected Index index;
	protected InputStream source;

	public void setProject( final Project project) {
		this.project = project;
	}

	public void setName( final String name) {
		this.name = name;
	}

	public void setIndex( final Index index) {
		this.index = index;
	}

	public void setSource( final InputStream source) {
		this.source = source;
	}

	public void execute() throws Exception {
		DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		generate( builder.parse( source));
	}

	protected abstract void generate( Document document) throws Exception;
}
